---
title: Set a conditional breakpoint
slug: Tools/Debugger/How_to/Set_a_conditional_breakpoint
tags:
  - Conditional
  - Debugger
  - Debugging
  - DevTools
  - Developer Tools
  - Firefox
  - Guide
  - JavaScript debugging
  - Tools
  - WM
  - breakpoint
---
<div>{{ToolsSidebar}}</div>

<p>A normal breakpoint is just associated with a line: when the program reaches that line, the debugger pauses. A conditional breakpoint also has a condition associated with it, which is represented as an <a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Expressions">expression</a>. When the program reaches the line, the debugger pauses only if the breakpoint's specified expression evaluates to <code>true</code>.</p>

<p>This makes it possible to debug specific scenarios, such as bugs that only happen on odd entries in a list, or errors that occur the last time through a loop, for example.</p>

<p>{{EmbedYouTube("pVPlMhfrMwM")}}</p>

<p>To set a conditional breakpoint, activate the context menu in the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_pane">source pane</a>, on the line where you want the breakpoint, and select "Add Conditional Breakpoint". You'll then see a textbox where you can enter the expression. Press <kbd>Return</kbd> to finish.</p>

<p>Conditional breakpoints are shown as orange arrows laid over the line number.</p>

<p>If you context-click on any breakpoint, you'll see a menu item "Edit Breakpoint". You can use this to modify an existing condition or to add a condition to a normal breakpoint.</p>
